/**
 * \class adc
 *
 *
 * \author ne0/ac/sort
 *
 * \version 1.0
 *
 * Contact: ealvarado@elo.utfsm.cl, spizarro@elo.utfsm.cl, gvalinm@elo.utfsm.cl
 *
 */

#ifndef _ADC_H
#define	_ADC_H
#include  <cmath>
#include <TROOT.h>

/**
 * \brief This class allows to generate errors relative to the physical limitated converters.
 */
class adc {
public:
	/**
	Creates an analog to digital converter instance.
	\param _nbits bits of presicion.
	\param _max upper voltage value.
	\param _min lower voltage value.
	*/
    adc(Int_t _nbits, Int_t _max, Int_t _min);
	/**
	Changes the upper voltage value of the ADC.
	\param _max upper voltage value.
	*/
    void setMax(Int_t _max);
	/**
	Changes the lower voltage value of the ADC.
	\param _min lower voltage value.
	*/
    void setMin(Int_t _min);
	/**
	Convert an analog measure into a digital value.
	\param data Analog measure.
	\return Digital value of the measure.
	*/
    Float_t Convert(Float_t data);
    ~adc();

private:
    Int_t nbits;
    Int_t max;
    Int_t min;
};

#endif	/* _ADC_H */

