/* 
 * File:   analyzer.cpp
 * Author: ne0
 * 
 * Created on June 11, 2009, 1:27 AM
 */

#include "analyzer.h"

/*
	Float_t rangolineal;
	Float_t tolerancia;
	Int_t sipm;
	string inputFilename;
	string outputFilename;
*/

analyzer::analyzer(Float_t rango, Float_t toleran, string file, string file2) {
	inputFilename=file;
	outputFilename=file2;
	tolerancia=toleran;
	rangolineal=rango;
}

void analyzer::setSipm(Int_t setSipm){	
	sipm=setSipm;
}	

void analyzer::analyze(Float_t & V1, Float_t & V2){
	
	TFile * f = new TFile(inputFilename.c_str());
	TNtuple * t1 = (TNtuple*)f->Get(inputFilename.c_str());
	Float_t ps,pt,pv,pc;
        t1->SetBranchAddress("s",&ps);
        t1->SetBranchAddress("t",&pt);
        t1->SetBranchAddress("v",&pv);
	t1->SetBranchAddress("c",&pc);
	
	vector<Float_t> sv;
	vector<Float_t> tv;
	vector<Float_t> vv;
	vector<Float_t> cv;
	Int_t vcounter=0;
	Float_t vmin=0;
	Float_t vmax=0;

	Int_t nentries = (Int_t)t1->GetEntries();
	for (Int_t i=0; i<nentries ; i++) 
	{
	t1->GetEntry(i);
	if((int)ps==(int)sipm) // Get data from one sipm at the time
		{
		vcounter++;
		sv.push_back(ps);
		tv.push_back(pt);
		vv.push_back(pv);
		cv.push_back(pc);
		// Use iterators here
		if(pv<vmin) vmin=pv;
		if(pv>vmax) vmax=pv;
		
		}
	}
       
	// We have vcounter elements
	// vv voltage vector
	// tv temperature vector
	// cv current vector
	Float_t pendiente;
	Float_t pendienteMedia;
	Float_t errorLocal;
	Float_t errorMinimo=9999999.9;			
	Float_t vbegin,cbegin,vfinal,cfinal;
	Int_t iminimo=0;
	
	for(Int_t i=0; i+(rangolineal*100) <= vcounter ; i++){ // Move the windows to analyze data //
		//get limits
		vbegin=vv[i];
		cbegin=cv[i];
		//find upper limit
		vfinal=vv[i+(rangolineal*100)]; // obtenemos el segundo punto
		cfinal=cv[i+(rangolineal*100)];
		//pendiente puntos extremos
		pendiente = (cfinal-cbegin)/(vfinal-vbegin); 
		pendienteMedia=pendiente;
		errorLocal=0;
		for(Int_t k = 0 ;k < 100 ; k++){
			pendiente = pendienteMedia-(((Float_t)k)/10)-(10/2);
			//recoremos el rango
			for(Int_t j = i; j<i+(rangolineal*100) ; j++){ 
				//sumamos el error
				Float_t iteorico= vv[j]*pendiente + (cbegin-vbegin*pendiente) ; 
				errorLocal=errorLocal + (iteorico-cv[j])*(iteorico-cv[j]);
	
			}
		if(errorLocal<errorMinimo) {errorMinimo=errorLocal;	iminimo=i;}
		}		
		
	}	

	V1=vv[iminimo]; V2=vv[iminimo]+rangolineal;	
}


analyzer::~analyzer() {
}

