/**
 * \class analyzer
 *
 * \author ne0/ac/sort
 *
 * \version 1.0
 *
 * Contact: ealvarado@elo.utfsm.cl, spizarro@elo.utfsm.cl, gvalinm@elo.utfsm.cl
 *
 */

#ifndef _ANALYZER_H
#define	_ANALYZER_H
#include <TROOT.h>
#include <iostream>
#include <string>
#include <TGraph.h>
#include <TCanvas.h>
#include <TGraphSmooth.h>
#include <TTree.h>
#include <TFile.h>
#include <TNtuple.h>
#include <vector>

using namespace std;

/**
 * \brief This class reads cern-root-ntuples and determinates the most linear zone depending upon input parameters.
 * Writes most linear range in text file. 
 */
class analyzer {
public:
	/**
	Creates an analyzer instance.
	\param rango Operation range.
	\param toleran Maximum allowed tolerance.
	\param file File from which to read the ntuples.
	\param file2 Outputs the most linear range.
	*/
    analyzer(Float_t rango, Float_t toleran, string file, string file2);
	/**
	Sets the SiPM ID to be analyzed.
	\param setSipm SiPM's identifier.
	*/
    void setSipm(Int_t setSipm);
	/**
	Does the analysis!
	*/
    void analyze(Float_t & V1, Float_t & V2); 
    virtual ~analyzer();
private:
	Float_t rangolineal;
	Float_t tolerancia;
	Int_t sipm;
	string inputFilename;
	string outputFilename;
};

#endif	/* _ANALYZER_H */
