/**
 * \class dac
 *
 *
 * \author $Author: ne0/ac/sort $
 *
 * \version $Revision: 1.0 $
 *
 * \date $Date: $
 *
 * Contact: ealvarado@elo.utfsm.cl, spizarro@elo.utfsm.cl, gvalinm@elo.utfsm.cl
 *
 */

#ifndef _DAC_H
#define	j_DAC_H
#include <cmath>
#include <TFile.h>

/**
 * \brief This class allows to generate errors relative to the physical limited converters.
 */
class dac {
public:
	/**
	Creates a digital to analog converter with default values.
	*/
    dac();
	/**
	Creates a _nbits digital to analog converter.
	\param _nbits bits of precision
	*/
    dac(Int_t _nbits);
	/**
	Creates a _nbits DAC which operates in _min and _max range.
	\param _nbits bits of precision
	\param _max upper voltage value
	\param _min lower voltage value
	*/
    dac(Int_t _nbits, Float_t _max , Float_t _min);
    ~dac();
	/**
	Does a conversion from a digital value to an analog one.
	\param _Input Digital value.
	\return Analog value.
	*/
    Float_t Convert(Float_t _Input);

private:
    Int_t nbits;
    Float_t max;
    Float_t min;
};

#endif	/* _DAC_H */

