/* 
 * File:   filegenerator.cpp
 * Author: Shiroi
 * 
 * Created on June 11, 2009, 1:27 AM
 */

#include "filegenerator.h"


filegenerator::filegenerator() {
	m_sFileName = "data.file";
}

/* filegenerator constructor
	Just gets the filename to work on !
*/
filegenerator::filegenerator(const string & fileName) {
	m_sFileName = fileName;
}

/* openW() method
	Opens a file for writing into.
*/
bool filegenerator::openW() {
	m_fWrite.open (m_sFileName.c_str(), ios::out | ios::app);
	if (m_fWrite.is_open()) return true;
	else return false;
}

/* writeFile(const Int_t & id, const Float_t & zeroValue, const Float_t & spanValue) method
	Write values to a file, separated by lines.

	Returns: 1 success, 0 failure.
*/
bool filegenerator::writeFile(const Int_t & id, const Float_t & zeroValue, const Float_t & spanValue) {
	if(m_fWrite.is_open()) {
		m_fWrite << setfill('0');
		m_fWrite << setw(10) << id << "\t";
		m_fWrite << setw(10) << zeroValue << "\t";
		m_fWrite << setw(10) << spanValue << endl;
		return true;
	}
	else return false;
}

/* openR() method
	Opens a file to read from.
*/
bool filegenerator::openR() {
	m_fRead.open (m_sFileName.c_str());
	if (m_fRead.is_open()) return true;
	else return false;
}

/* readFile(Int_t & id, Float_t & zeroValue, Float_t & spanValue) method
	Reads data from a line of the file and store its values in the reference vars.

	Observations: File is formatted as follows
	
	ID		ZEROVALUE	SPANVALUE
	XXXXXXXXXX	YYYYYYYYYY	ZZZZZZZZZZ
	XXXXXXXXXX	YYYYYYYYYY	ZZZZZZZZZZ

	Having a different file format will cause this function to fail horribly :(

	Returns: 1 success, 0 failure.
*/
bool filegenerator::readFile(Int_t & id, Float_t & zeroValue, Float_t & spanValue) {
	string line;
	char rawRead[12];
	if (!m_fRead.eof() ) {
		rawRead[11] = '\0';
		m_fRead.read(rawRead,11);
		id = atoi(rawRead);
		m_fRead.read(rawRead,11);
		zeroValue = atof(rawRead);
		m_fRead.read(rawRead,10);
		spanValue = atof(rawRead);
		m_fRead.getline(rawRead,10);
		if (id == 0 && zeroValue == 0 && spanValue == 0) return false;
		else return true;
	}
	else return false;
}

/* filegenerator destructor.
	Just closes any file which could be open.
*/
filegenerator::~filegenerator() {
	if (m_fRead.is_open()) m_fRead.close();
	if (m_fWrite.is_open()) m_fWrite.close();
}

