/**
 * \class heatsource
 * \author ne0/ac/sort
 * \version 1.0
 *
 * Contact: ealvarado@elo.utfsm.cl, spizarro@elo.utfsm.cl, gvalinm@elo.utfsm.cl
 *
 */

#ifndef _HEATSOURCE_H
#define	_HEATSOURCE_H
#include "source.h"
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <TRandom.h>

using namespace std;

/**
 * \brief This class is intented for its use in building the hardware and the world to simulate.
*/
class HeatSource:public source{
public:
	/**
	Default new instance of a heat source.
	*/
    HeatSource();
	/**
	New instance of a heat source.
	\param _max Upper heat value
	\param _min Lower heat value
	\param _precision Tolerance of measures.
	*/
    HeatSource(Float_t _max, Float_t _min, Float_t _precision);
	/**
	Creates a copy of a heatsource instance.
	\param orig another heatsource
	*/
    HeatSource(const HeatSource& orig);
    virtual ~HeatSource();
	/**
	Gets heat value.
	\return The temperature!
	*/
    Float_t getOutput();
    bool operator<(Float_t);
	/**
	Sets the output.
	*/
    void setOutput(Float_t);
    bool operator>(Float_t);
private:
    Float_t Precision;
};

#endif	/* _HEATSOURCE_H */

