/**
 * \class lightguide
 *
 * This class provides physical and visual demostration of efficency in an actual lightguide.
 *
 * \author $Author: ne0/ac/akis $
 *
 * \version $Revision: 1.0 $
 *
 * \date $Date: $
 *
 * Contact: ealvarado@elo.utfsm.cl, spizarro@elo.utfsm.cl, gvalinm@elo.utfsm.cl
 *
 */
#ifndef _LIGHTGUIDE_H
#define	_LIGHTGUIDE_H

#include "TMath.h"
#include "TStopwatch.h"
#include "TSystem.h"
#include "TVector3.h"
#include "TStyle.h"
#include "TCanvas.h"
#include "TH2.h"
#include "TH3.h"
#include "TRandom.h"
#include "TGeoManager.h"
#include "TEveManager.h"
#include "TGeoTube.h"
#include "TGeoMatrix.h"
#include "TEveArrow.h"
#include "TEveGeoNode.h"
#include <TROOT.h> 
#include "TApplication.h"
#include "TPaveLabel.h"
#include "TLine.h"

/**
 * \brief This class provides physical and visual demostration of efficency in an actual lightguide.
*/
class lightguide {
public:
	/**
	Creates a lightguide instance with n rays.
	\param simulate3D Does a graphical simulation.
	\param _numberOfEvents Number of rays in the simulation.
	*/
    lightguide(Int_t simulate3D, Int_t _numberOfEvents);
	/**
	Runs the lightguide simulator.
	*/
    void run();
    ~lightguide();

private:
	Int_t numberOfEvents;
	Bool_t SHOW_3D;
	Bool_t DEBUG;
	Bool_t SHOW_NORMALS;
	Bool_t SHOW_INTERSECTION;



};

#endif	

