/* 
 * File:   main.cpp
 * Author: ne0
 *
 * Created on June 10, 2009, 11:27 PM
 */
#include <TROOT.h>
#include <TTree.h>
#include <TNtuple.h>
#include <TFile.h>
#include <iostream>
#include <sstream>
#include "adc.h"
#include "filegenerator.h"
#include "meter.h"            
#include "pmt.h"  
#include "source.h"
#include "analyzer.h"
#include "hardware.h"      
#include "ntuplegenerator.h"  
#include "sensor.h"  
#include "voltagesource.h"
#include "heatsource.h"  
#include "dac.h"          
#include "photomultiplier.h"  
#include "sipm.h"
#include "lightguide.h"
#include "draw.h"

using namespace std;
//Int_t hardware::hid = 0;

int main(int argc, char** argv) {
	//switch
	string filename="default.out";
  	Int_t NGraphs=4;
	Int_t N_PMT=256;
	Int_t E=0;
	Int_t X=0;
	Int_t D=1;
	Float_t temp=-20;
	Int_t RAYOS=5;
	Int_t N_DATA=500;
	if(argc<2){ 
		cout << "Try 'SPiM --help' or 'SPiM -h'" <<endl;
		return -1;
	}
	if (!strcmp(argv[1],"-h") || !strcmp(argv[1],"--help")){ 
		cout<<"Uso:"<<endl;
		cout<<"SiPM --simulate[-s] --number[-n] N_PMT --output[-o] OUTPUT_FILE"<<endl;
		cout<<"SiPM --display[-d] --input[-i] INPUT_FILE"<<endl;
		cout<<"SiPM --x[-X] ON(1)/OFF(0) --n[-N] N_RAYS"<<endl<<endl;

		cout<<"Opciones simulación:"<<endl;
		cout<<"-n,\t --number\t\t Especifica cantidad de sensores para simulacion. 256 por defecto."<<endl;
		cout<<"-o,\t --output\t\t Nombre del archivo de salida."<<endl;
		cout<<"-e,\t --error\t\t Error porcentual de la medición por los sensores."<<endl<<endl;		

		cout<<"Opciones display:"<<endl;
		cout<<"-i,\t --input\t\t Nombre del archivo de entrada."<<endl<<endl;	

		cout<<"Opciones graficas:"<<endl;	
		cout<<"-x,\t --X\t\t\t Despliegue por sistema de ventanas. (1) Grafico 3D, (0) Grafico 2D."<<endl;		
		cout<<"-n,\t --N\t\t\t Cantidad de rayos incidentes, numero entero."<<endl<<endl;		

	}
	if (!strcmp(argv[1],"-s") || !strcmp(argv[1],"--simulate")){
		for(Int_t i=0;i<argc;i++){ 
			if(!strcmp(argv[i],"-o") || !strcmp(argv[i],"--output")){
				filename=argv[i+1];
			}
			if(!strcmp(argv[i],"-n") || !strcmp(argv[i],"--number")){
				stringstream ss;
				ss<<argv[i+1];			
				ss>>N_PMT;
			}
			if(!strcmp(argv[i],"-e") || !strcmp(argv[i],"--error")){
				stringstream ss;
				ss<<argv[i+1];			
				ss>>E;
			}
			if(!strcmp(argv[i],"-t") || !strcmp(argv[i],"--temp")){
				stringstream ss;
				ss<<argv[i+1];			
				ss>>temp;
			}
			if(!strcmp(argv[i],"-m") || !strcmp(argv[i],"--muestras")){
				stringstream ss;
				ss<<argv[i+1];			
				ss>>N_DATA;
			}
		}
		VoltageSource Vsource =  VoltageSource(0.0, 200.0, 0.004);
		HeatSource Tsource =  HeatSource(20.0,-20.0, 0.5);
		sensor Sensor = sensor(10);
		hardware Hardware[N_PMT];
		ntuplegenerator Ntupler(filename);
		//sipm  Sipm =  spm(0.0,0.0, Vsource, Tsource,35.5);
		sipm ASipm[N_PMT];
		cout << "Creating World" << flush;		
		for(Int_t i=0;i<N_PMT;i++){ 
			cout << "." << flush;
			sleep(1);			
			Vsource.setOutput(35.5-2.5+(Float_t)i*(Float_t)(5.0/(Float_t)N_PMT));
			Tsource.setOutput(temp);
			sipm  Sipm =  sipm(0.0,0.0, Vsource, Tsource,35.5);
			//cout<<"entrada t:\t"<<Tsource.getOutput()<<endl;
			Hardware[i].setTemperature(Tsource); 
			Hardware[i].setVoltageSource(Vsource); 
			Hardware[i].connectSipm(Sipm);
			Hardware[i].setID(i);
			Hardware[i].connectSensor(Sensor);
			ASipm[i]=Sipm;			
		}
		cout << endl;
		cout << "Simulation" << flush;
		for(Int_t i=0;i<N_DATA;i++){
			cout << "." << flush;
			for(Int_t j=0;j<N_PMT;j++){
				// cout << endl << "Next Stage " 	;		
				
			//cout <<  (Float_t)(35.5-2.5+(Float_t)i*(Float_t)(5.0/(Float_t)N_DATA)) << endl;
			//Vsource.setOutput( (Float_t)(35.5-2.5+(Float_t)i*(Float_t)(5.0/(Float_t)N_DATA)) ) ;
			//Hardware[i].setNewTemp((Float_t)(35.5-2.5+(Float_t)i*(Float_t)(5.0/(Float_t)N_DATA)));
			//cout << "0: " <<  Vsource.getOutput() << endl;
			//cout << "m " << (Float_t)(35.5-2.5+(Float_t)i*(Float_t)(5.0/(Float_t)N_DATA)) << endl;
//			cout << "m " << Hardware[j].getMeasureVoltage() << endl;
			//cout << Hardware[j].getMeasureVoltage()
			Ntupler.fill(Hardware[j].getID(),Hardware[j].getTemperature(),(Float_t)(35.5-2.5+(Float_t)i*(Float_t)(5.0/(Float_t)N_DATA)),ASipm[j].getMeasureCurrent((Float_t)(35.5-2.5+(Float_t)i*(Float_t)(5.0/(Float_t)N_DATA)),temp ) );

				}
				Ntupler.writefile();
			}

		cout << endl;
		

		//Ntupler.showfile();		
		return 0;
	}

	else if (!strcmp(argv[1],"--display") || !strcmp(argv[1],"-d") ){
		for(Int_t i=0;i<argc;i++){ 
			if(!strcmp(argv[i],"-i") || !strcmp(argv[i],"--input")){
				filename=argv[i+1];
			}
		}

		TFile *myfile = new TFile(filename.c_str());
		TTree *T = (TTree*)myfile->Get(filename.c_str());
		//Event *event = new Event();
		TBranch *s = T->GetBranch("s");
		TBranch *t = T->GetBranch("t");
		TBranch *v = T->GetBranch("v");
		TBranch *c = T->GetBranch("c");
		
		Int_t nevent = T->GetEntries();
		Int_t nselected=0;
		Int_t nb=0;
		for(Int_t i=0;i<nevent;i++){
			s->GetEntry(i);
		
		nb+=T->GetEntry(i);
		nselected;
		//asdf->Show();
		}
		T->Scan("s:t:v:c");

		return 1;
	}

//////////////////////////////////CAMBIOS

else if (!strcmp(argv[1],"--A") || !strcmp(argv[1],"-a") ){  
   string fn1="default.in"; 
   string fn2="default.out";
	for(Int_t i=0;i<argc;i++){ 
  if(!strcmp(argv[i],"-i") || !strcmp(argv[i],"--input")) 
    fn1=argv[i+1]; 
  if(!strcmp(argv[i],"-o") || !strcmp(argv[i],"--output")) 
    fn2=argv[i+1]; 
	}
	cout << "analyze file: " << fn1 << endl;
	cout << "write to file: " << fn2 << endl;
	Float_t V1, V2;

	filegenerator * wFile  = new filegenerator(fn2);
  wFile->openW();

	analyzer * A = new analyzer(0.2, 0.1, fn1, fn2);
        A->setSipm(0);
        A->analyze(V1,V2); 
	wFile->writeFile(0,V1,V2);
  

	analyzer * A2 = new analyzer(0.2, 0.1, fn1, fn2);
        A2->setSipm(1);
        A2->analyze(V1,V2); 
	wFile->writeFile(1,V1,V2);


	analyzer * A3 = new analyzer(0.2, 0.1, fn1, fn2);
        A3->setSipm(2);
        A3->analyze(V1,V2); 
	wFile->writeFile(2,V1,V2);

	
	analyzer * A4 = new analyzer(0.2, 0.1, fn1, fn2);
        A4->setSipm(3);
        A4->analyze(V1,V2); 
	wFile->writeFile(3,V1,V2);


}

else if (!strcmp(argv[1],"--G") || !strcmp(argv[1],"-g") ){  
   string fn1="default.out"; 
	 string fn2;
	 for(Int_t i=0;i<argc;i++){ 
   		if(!strcmp(argv[i],"-i") || !strcmp(argv[i],"--input")){ 
    		fn1=argv[i+1]; 
	    } 
   		if(!strcmp(argv[i],"-p") || !strcmp(argv[i],"--parameters")){ 
   		  fn2=argv[i+1]; 
   		} 
   		if(!strcmp(argv[i],"-n") || !strcmp(argv[i],"--ngraphs")){ 
				stringstream ss;
				ss<<argv[i+1];			
				ss>>NGraphs;
   		} 
   }
   cout << "display file" << endl; 
   string a,b,c,d = "x";

		Int_t id[NGraphs];
		Float_t x1[NGraphs],x2[NGraphs];
		for(Int_t i=0;i<NGraphs;i++){x1[i]=0;x2[i]=0;}
		filegenerator * p;
		p = new filegenerator(fn2);
		p->openR();
			for(Int_t i=0;i<NGraphs;i++)  if(!p->readFile(id[i],x1[i],x2[i])) ;/*cout<<"Nos quedamos sin lineas que leer, lloremos )':"<<endl;*/


	Float_t a1,a2,b1,b2,c1,c2,d1,d2=0.0;
	draw * dr = new draw(fn1);
	a="t>-21.0 && t<-19.0 && s==0"; 
	b="t>-21.0 && t<-19.0 && s==1";
	c="t>-21.0 && t<-19.0 && s==2";	
	d="t>-21.0 && t<-19.0 && s==3";	
 	dr->setTextFile(a,b,c,d);
	dr->setMaxMin(x1[0],x2[0],x1[1],x2[1],x1[2],x2[2],x1[3],x2[3]);
    	dr->run();
}

	else if (!strcmp(argv[1],"--x") || !strcmp(argv[1],"-X") ){
		for(Int_t i=0;i<argc;i++){ 
			if(!strcmp(argv[i],"--x") || !strcmp(argv[i],"-X")){
				stringstream ss;
				ss<<argv[i+1];			
				ss>>D;
			}
			if(!strcmp(argv[i],"--n") || !strcmp(argv[i],"-N")){
				stringstream ss;
				ss<<argv[i+1];			
				ss>>RAYOS;
			}
		}

			cout<<D<<" "<<RAYOS<<endl;
			lightguide *lg= new lightguide(D,RAYOS);
			lg->run();

	}	

	else if (!strcmp(argv[1],"--camila")){
		cout	<<"OO$OOZO$O88$I7ZZO888DDDDDDDDDDDDD8DD8OZ8ZODD8D8OO8OOZ88888DD8O8$OO8OZO8DZZ$OZZ$$"<<endl
			<<"888OOZOZ$ZDZ7O8$7III7II?III7$ODDNDDDDD8OOOO888O8OZOD8DD88888888O88OOOOO8DO87IZZ$"<<endl
			<<"OO8O8O8O$8O$$O$+=~======?+????7ODDDDDD8OOZOO8OO8O88O8D88O88OO8O8D88D88OO8OZOOO$Z"<<endl
			<<"Z$ZZOD8888ZZ$$?=~~~~~=I7I$$?+=?IZDDDD8D88ZZO88OO8888888DD8ZZO88O8OO8D88ODZ$ZOOZO"<<endl
			<<"7$O7O888DDZZOO$=~~~~=I$7IZI+~=+?I$DDDDDOD8ZZOO8OZZOZZ8O$ZZ$7Z8OZ8DD8O888OZZZ$ZZ8"<<endl
			<<"?$8ZO8888888DD8=~~===+II7?=~:~=+?7ZDDD8OODZO8OO$$7II?+?II=~=I$888888OO88OZOOOOZ$"<<endl
			<<"I$O8Z$8888Z8DND?~~=+=~=?+=~:~~=+?I7D8D888DO$888OZ?:~~:::==~,,+$8888DO$888D8D88ZO"<<endl
			<<"O$O8$Z88D8O8DNND?IZZOI,:++====++??IDDD8ODD8ZZ88O?+=~,,::,....:+Z88Z888OOOO8ZZOZO"<<endl
			<<"ZO8O8888OO8ODNNNN8$OI+~,~+?7==?I??I8NDOODDDOOOOO7+~~~=~,,...,:=?OOOOZ8O8ZZOZOOOO"<<endl
			<<"ZOO8Z8Z8DDD8DNNNNNNO~::~+II++?OZ???ODDOODDND888ZZO?~~~::,,,,,:~=+DDD888D888Z8888"<<endl
			<<"8OOOO8D8OO888DNNNNNN+~~+?==II7$I?IIZD8Z8DDD888888O+:~~,,,,:::~~+OOO88D88ZZD8OOO8"<<endl
			<<"O87$D8DOOON88DNNNNNNNNO$7I$ZO$I7I+?8NOZ8DDDDDDD88OZ?,,,:~=~~~~$OO8OOO8DND8OZO8O8"<<endl
			<<"O8ZD888ZZO8O88NDNNNNNNNNN8$7??I+++INN8Z8DDDDDD888OOO$+?7$$7=$8OO88O8OOOO8ZZO8888"<<endl
			<<"O88D8Z7?I7ZZOO8DDDDNNNNNNNND8ZI?I$8NN8O8DNDDDD888OOOOOOOOOOZOOO8O8888OOO8OZOOOOO"<<endl
			<<"OD8D8Z?+~=7ZOOODDDDDDNNNNNNNNNNNDD8DDDO8DNNNDD88OOOOOOOOOOOOOOOOOO8888OOOO8Z$7$Z"<<endl
			<<"OOOZOO+~:~+7ZZZ8ODDDDDNDNNNNDNNNDN8O8DDDDNNND88OOOOOOOOOOOOOOOZOOOOOO888OOZ$$$77"<<endl
			<<"OZ87?$=::~=?+I$ZODDDDDNDDDDDDNNNNNDO8DD88DNNDD88OOOOOOOOOOOO88OOOOOOO88888O8OZ$7"<<endl
			<<"7$Z+~~::,:==~+$+Z88DDD8DDDO8DD8DDDD88888O8DDD8OOOOOOOOOOOOOOZOO88OOOOO88888O8887"<<endl
			<<"7$$===::~~==~=?+$O888DNNDDDZOZZO8DDDDDDOO8DD8OOOOOOOOOOOOOOOZZ88OOOOOOO888888888"<<endl
			<<"ZI~:::,,=++~~~~IZOO8$Z8DZDDZ7Z$ZZZOODD8OO8OOOOOOOOOOOOOOOOO8OZZO8OOOZOO888888888"<<endl
			<<"Z7:::...~I=::::+IZOO7Z8D888OZOOZ$$ZZO8OZZZZOOOZOOOOOOOOOOOOO8888OOZZ8OO88O888888"<<endl
			<<"$$?=~..,=I++=+?I7Z88OD888OODOZ$$7$Z$$$$$$$$ZZZZZOOOOO888O88OO8O8OZOZZZOO88888888"<<endl
			<<"$I+=:..:+7?IIII77O88ODO88O$DO$$77$Z$$7$$$$ZZZZZZOOOO8888888OOO88OZZZZZOOO8888888"<<endl
			<<"77?+,,~+7$I?IIII7OO888Z78O7$OO$7$Z$$77$$$$ZZZZOOOO88888888D88$7$OOZZZZ8OOO888888"<<endl
			<<"++==,=+I$Z??I77Z77$$O$Z$Z$O8O$ZZZ$$777$$$$ZZOOOO8O8888888888O7+???7ZZZ8ZO8888888"<<endl
			<<"+++?=~+?I$Z8Z$$7I77I?+I7Z7$$77$$$$777777$ZZZOOOOOO8888888888OI?+?++++?ZZZO888888"<<endl
			<<"++++?~=?I$8D8$77I???+??I$I$$77ZZZZ$$77$$ZZOOOO88888888888OOOOI????+?++++I7ZO8888"<<endl
			<<"+++++?Z8O88DD88++++++++77I$$$$ZOOZZ$$$$ZOOOOOO88888888888OOOZ?++==++=+=+++++?$O8"<<endl
			<<"~===++?ZZOD88DDD8I====?88Z$$$$ZZOZZ$$$ZZOOO88888888888888OOO7+++++++=+++++++++++"<<endl
			<<"?+??I7$7ZODD88D88DDOI777O8ZZZZZZOOZ$$$ZZOOO888888OO88888OOOO777I????+???????????"<<endl
			<<"$$$$$7$Z$88O888DDDD8OOZZ88ZOOOZZZOZ$$$$ZOOOOOOOOOOO888888OOO$$777I7777I????++++?"<<endl
			<<"ZZZZOZZ$ZZOOOO8888D8DDD888ZD8OOOZOO$$7ZZZOOOOOOOOOO888888OOO77777777$7777I777II?"<<endl;
			cout << endl << "Camila Galaz <3" <<endl <<endl;	
		return 2;
	}

	else {
		cout << "Try 'SPiM --help' or 'SPiM -h'"<<endl;	
	}
	//Analyzer analyzer(rango, tolerancia,"raw.out","ppcesed.out");
	//analyzer.setSpim(spim);
	//analyzer.analyze(V1,V2);
	//cout << argv[1] <<endl;

    return 69;

}	
