/**
 * \class ntuplegenerator
 *
 * This class reads cern-root-ntuples and determinates the most linear zone depending upon input parameters.
 * Writes most linear range in text file. 
 *
 * \author $Author: ne0/ac/akis $
 *
 * \version $Revision: 1.0 $
 *
 * \date $Date: $
 *
 * Contact: ealvarado@elo.utfsm.cl, spizarro@elo.utfsm.cl, gvalinm@elo.utfsm.cl
 *
 */

#ifndef _NTUPLEGENERATOR_H
#define	_NTUPLEGENERATOR_H

#include <string>
#include <iostream>
#include <TTree.h>
#include <TNtuple.h>
#include <TFile.h>

using namespace std;
/**
 * \brief This class allows to generate files for the ntuple class of ROOTCern.
 */
class ntuplegenerator {
public:
		/// Void class constructor.
    ntuplegenerator();
		/// Class constructor with a string (filename) to be saved.
    ntuplegenerator(string name);
		/// Method used to fill the (filename) with data.
    void fill(Int_t sipmid, Float_t temp, Float_t voltage, Float_t current);
		/// Writes in (filename).
    void writefile();
		/// Shows (filename). Partially used for debugging.
    void showfile();
		/// Prints a formatted (filename). Partially used for debugging.
    void drawfile(Int_t sipmid, Float_t temp);
		/// Class destructor.
    virtual ~ntuplegenerator();
private:
    string  filename; /// string (filename) used to store information on hdd.
    TFile * file; 		/// pointer to the actual physical location on hdd. 
    TNtuple *ntuple;	/// ROOTCern class for optimal storing of generated data.
};

#endif	/* _NTUPLEGENERATOR_H */

