/* 
 * File:   Photomultiplier.cpp
 * Author: ne0
 * asdasdasdasd
 * Created on June 11, 2009, 1:29 AM
 */

#include "photomultiplier.h"

Photomultiplier::Photomultiplier() {
}

Photomultiplier::Photomultiplier(const Photomultiplier& orig) {
}

Photomultiplier::Photomultiplier(Float_t _MagneticAngle, Float_t _MagneticMagnitude, VoltageSource  &_InputVoltage, HeatSource  &_InputTemperature, Float_t _BreakdownVoltage){
	Seed=getRandom();
	MagneticAngle=_MagneticAngle;
	MagneticMagnitude=_MagneticMagnitude;
	InputTemperature=_InputTemperature;
	InputVoltage=_InputVoltage;
	BreakdownVoltage=_BreakdownVoltage;
	setGain();
	setDarkCurrent();
}


Photomultiplier::~Photomultiplier() {
}

  void Photomultiplier::setMagneticField(Float_t _MagneticMagnitude, Float_t _MagneticAngle){
	MagneticAngle=_MagneticAngle;
	MagneticMagnitude=_MagneticMagnitude;
	setGain();
	//setDarkCurrent();
}

void Photomultiplier::setTemperature(HeatSource &_InputTemperature){
	this->InputTemperature=_InputTemperature;
	//setGain();
	setDarkCurrent();
}

void Photomultiplier::setVoltage(VoltageSource &_InputVoltage){
	InputVoltage=_InputVoltage;
	//setGain();
	//setDarkCurrent();
}

void Photomultiplier::setGain(){	
	Gain_db=160;
	if(MagneticAngle==0) Gain_db+=0.0*Gain_db; 
	if(MagneticAngle>0 && MagneticAngle<180) Gain_db+=0.00056*Gain_db; 
	if(MagneticAngle==180) Gain_db+=0.1*Gain_db; 
	if(MagneticAngle>180 && MagneticAngle<360) Gain_db-=0.00056*Gain_db; 
}

void Photomultiplier::setDarkCurrent(){
	DarkCurrent=0.01;
	if(InputTemperature< -20.0) DarkCurrent=0.01;
	if((InputTemperature>  -20.0) && (InputTemperature <60.0)) DarkCurrent=0.1*(InputTemperature.getOutput());	
	if(InputTemperature>  60.0) DarkCurrent=0.15*InputTemperature.getOutput();	

}

Float_t Photomultiplier::getMeasureCurrent(){
	Float_t vmin = getBreakdownVoltage() + (0.05 + Seed*0.05)*getBreakdownVoltage();
	Float_t vmax = getBreakdownVoltage() - (0.05 + Seed*0.05)*getBreakdownVoltage();
	Float_t imin = 0;
	Float_t imax = 60 + 10*Seed; 
	Float_t pendiente = (imax-imin)/(vmax-vmin);
  Float_t voltage = InputVoltage.getOutput();
	Int_t   parts = (Int_t)(Seed*1000);
	Float_t delta = (vmax-vmin)/parts;
	return ((voltage*pendiente));
}

Float_t Photomultiplier::getBreakdownVoltage(){
	sensor *Sensor = new sensor(11);
  Float_t res;
	res=Sensor->getMeasure(BreakdownVoltage);
	delete Sensor;
	return (res);


}
Float_t Photomultiplier::getRandom(){
	srand ( time(NULL) ); 
	return (Float_t)(rand() % 101)/100.0;
}

//Float_t Photomultiplier::getMeasureCurrent(){return 0.0;}

Float_t Photomultiplier::getMeasureVoltage(){return 0.0;}

