/**
 * \class pmt
 *
 *
 * \author $Author: ne0/ac/akis $
 *
 * \version $Revision: 1.0 $
 *
 * \date $Date: $
 *
 * Contact: ealvarado@elo.utfsm.cl, spizarro@elo.utfsm.cl, gvalinm@elo.utfsm.cl
 *
 */
#ifndef _PMT_H
#define	_PMT_H
#include <TFile.h>
#include "photomultiplier.h"

/**
* \brief This class implements a different sensor other than class sipm. Its main difference is related to the methods that are used to relate voltage and current. 
*/
class PMT:public Photomultiplier {
public:
	/**
	Creates an instance of a photomultiplier.
	*/
    PMT();
	/**
	Gets photomultiplier current measure.
	\return Current measure
	*/
    Float_t getMeasureCurrent();
	/**
	Gets photomultiplier voltage measure
	\return Voltage measure
	*/
    Float_t getMeasureVoltage();
    virtual ~PMT();
private:
    VoltageSource InputVoltage;
    HeatSource InputTemperature;
    Float_t Seed;
    Float_t DarkCurrent;
    Float_t Gain_db;
    Float_t MagneticAngle;
    Float_t MagneticMagnitude; 
    Float_t BreakdownVoltage; 
};

#endif	/* _PMT_H */

