/**
 * \class sensor
 *
 *
 * \author $Author: ne0/ac/akis $
 *
 * \version $Revision: 1.0 $
 *
 * \date $Date: $
 *
 * Contact: ealvarado@elo.utfsm.cl, spizarro@elo.utfsm.cl, gvalinm@elo.utfsm.cl
 *
 */
#ifndef _SENSOR_H_
#define	_SENSOR_H_
#include <cstdio>
#include <cstdlib>
#include <ctime>

#include <TH1.h>

/**
 * \brief This class provides some errors in the measurements to be done during the making of the simulation file.
*/
class sensor{
public:
	/// Default new sensor instance.
    sensor();
	/**
	Creates a new sensor instance
	\param _error Measurement error.
	*/
    sensor(Float_t _error);
	/**
	Gets a measure with error from a ideal measure.
	\param Ideal measure without error.
	\return measure with error.
	*/
    Float_t getMeasure(Float_t Ideal);
		~sensor() {;};
private:
    Float_t error;
		Int_t Seed;	  
};

#endif	/* _SENSOR_H */

