/* 
 * File:   sipm.cpp
 * Author: ne0
 * Clase SiPM
 * Created on June 10, 2009, 7:56 PM
 */

#include "sipm.h"

sipm::sipm() {
}

sipm::sipm(const sipm& orig) {
}

sipm::~sipm() {
}

void sipm::setVsource(VoltageSource &_InputVoltage){
	InputVoltage=_InputVoltage;
}

sipm::sipm(Float_t _MagneticAngle, Float_t _MagneticMagnitude, VoltageSource  &_InputVoltage, HeatSource  &_InputTemperature, Float_t _BreakdownVoltage){

	MagneticAngle=_MagneticAngle;
	MagneticMagnitude=_MagneticMagnitude;
	this->InputTemperature=_InputTemperature;
	this->InputVoltage=_InputVoltage;
	BreakdownVoltage=_BreakdownVoltage;
 	SeedUnico=setSeed();
	p1=(setSeed()/2.0)*5.0;
	p1=p1*0.9+getBreakdownVoltage()-2.5;
	p2=p1+(setSeed2()/2.0);
	if(p2>getBreakdownVoltage()+2.5) { p2 = getBreakdownVoltage()+2.5; p1=p1-1.0;}	
	//cout << p1 << " " << p2 << endl;
}

Float_t sipm::getMeasureCurrent(Float_t voltage, Float_t temp){
	
	 TRandom1 * asdf = new TRandom1();

	if(( asdf->Gaus(1,1) ) > 10) {
		setSeed(); 
	}
	
	Float_t vmax = getBreakdownVoltage() + (0.05*Seed+0.95)*getBreakdownVoltage();
	Float_t vmin = getBreakdownVoltage() - (0.05*Seed+0.95)*getBreakdownVoltage();
	Float_t imin = 0;
	Float_t imax = 60 + 5*(0.5)*Seed; 
	Float_t pendiente = (imax-imin)/(vmax-vmin);
	Int_t   parts = ((Int_t)(Seed)*0.5+0.5)*10;
	Float_t deltav = (vmax-vmin)/parts;
	Float_t deltai = (imax-imin)/parts;
	sensor *Sensor = new sensor(30);

	/* ACA EFECTO DE lA TEMPERATURA */
	temp=temp+100;
	temp=temp*0.1;
	Float_t rand = asdf->Gaus(1,1);
	delete asdf ;
	Float_t y=((0.05+0.95)*voltage*pendiente);
	Float_t k=30.0;
	for(Int_t i=0;i<4;i++){
	  y=y*y;
		k=k*k;
	}
	Float_t res=10*Sensor->getMeasure( y/k );

	Float_t y1=((0.05+0.95)*p1*pendiente);
	Float_t k1=30.0;
	for(Int_t i=0;i<4;i++){
	  y1=y1*y1;
		k1=k1*k1;
	}

	Float_t res1=10.0*( y1/k1 );

	Float_t y2=((0.05+0.95)*p2*pendiente);
	Float_t k2=30.0;
	for(Int_t i=0;i<4;i++){
	  y2=y2*y2;
		k2=k2*k2;
	}

	Float_t res2=10.0*( y2/k2 );

	Float_t pendiente2=(res2-res1)/(p2-p1);

	Float_t reslineal=Sensor->getMeasure(voltage*pendiente2-pendiente2*p1+res1);
	delete Sensor;
	//devuelve a la ^1
	if(voltage>p1 && voltage<p2)
		return reslineal + (rand*0.15*temp);
	//devuelve a la ^n
	else
		return res + (rand*0.4*temp);
	
}


Float_t sipm::getBreakdownVoltage(){
	sensor *Sensor = new sensor(10);
	Float_t voltage = Sensor->getMeasure(BreakdownVoltage);
	delete Sensor;
  return  voltage;
}


Float_t sipm::getMeasureVoltage(){
		return InputVoltage.getOutput();

}

Float_t sipm::setSeed(){
 
  TRandom1 * myrand = new TRandom1(time(NULL)%9999);
  do{Seed = myrand->Gaus(1,1);} while(Seed<=0.1 && Seed >=2.0);
  delete myrand;
	return Seed;

}

Float_t sipm::setSeed2(){
 	Float_t t;
  TRandom1 * myrand = new TRandom1(time(NULL)%9999);
  do{ t = myrand->Gaus(1.2,0.8);} while(t<=0.1 && t>=2.0);
  delete myrand;
	return t;

}
