/**
 * \class source
 *
 * This class it's parent of voltagesource and heatsource, contents and implements common methos and attributes.
 *
 * \author $Author: ne0/ac/akis $
 *
 * \version $Revision: 1.0 $
 *
 * \date $Date: $
 *
 * Contact: ealvarado@elo.utfsm.cl, spizarro@elo.utfsm.cl, gvalinm@elo.utfsm.cl
 *
 */
#ifndef _SOURCE_H
#define	_SOURCE_H
#include <TRandom.h>
#include <iostream>
using namespace std;
/**
 * \brief This class is parent to voltagesource and heatsource. It's used to build up the hardware class.
 */
class source {
public:
		///Class Void Constructor.
    source();
		///Class Copy Constructor. 
    source(const source& orig);
		///Class Destructor. 
    virtual ~source();
		///Method to get Output of the source.
    virtual Float_t getOutput();
		///Method to set Output of the source.
		void setOutput (Float_t _Output);
		///Class complete constructor to specifiy Maximum, Minimum value to represent the precision associated and finally the amount of bits to for the dac/adc.
    source(Float_t _Max, Float_t _Min, Float_t _Precision,Int_t _Nbits);
public:
    Float_t Output;    /// Output of the source (volts or celcius degrees)
    Float_t Precision; /// Precision, step between to possibly values of output.
    Float_t Max; 			 /// Max value to represent.
    Float_t Min; 			 /// Min value to represent.
    Int_t Nbits; 			 /// amount of Bits to use.
};
#endif	/* _SOURCE_H */
