/**
 * \class voltagesource
 *
 * This class is used to give realistic inestability of the power source that's to be used in creation of hardware class.
 *
 * \author $Author: ne0/ac/akis $
 *
 * \version $Revision: 1.0 $
 *
 * \date $Date: $
 *
 * Contact: ealvarado@elo.utfsm.cl, spizarro@elo.utfsm.cl, gvalinm@elo.utfsm.cl
 *
 */
#ifndef _VOLTAGESOURCE_H
#define	_VOLTAGESOURCE_H
#include "source.h"
#include <TROOT.h>
/**
 * \brief This class inhertis from source. It's used as power source for the hardware class.
 */
class VoltageSource : public source {
public:
	///Voltage Source Constructor	
   VoltageSource();
	///Voltage Source constructor, limits are set. Noise is set
    VoltageSource(Float_t _max, Float_t _min, Float_t _noise);
	///Destructor
    virtual ~VoltageSource();
	///Sets actual output voltage
    void setOutput (Float_t _Output);
	///Gets actual voltage with noise level.
    Float_t getOutput();
private:
    Float_t Noise;	
};


#endif	/* _VOLTAGESOURCE_H */

